



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java [Leetcode 338]Counting Bits</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java [Leetcode 338]Counting Bits</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 15:16:15 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目描述：</p>
<p>Given a non negative integer number&nbsp;num. For every numbers&nbsp;i&nbsp;in the range&nbsp;0 &le; i &le; num&nbsp;calculate the number of 1's in their binary representation and return them as an array.</p>
<p>Example:<br />For&nbsp;<code>num = 5</code>&nbsp;you should return&nbsp;<code>[0,1,1,2,1,2]</code>.</p>
<p>Follow up:</p>
<ul><li>It is very easy to come up with a solution with run time&nbsp;O(n*sizeof(integer)). But can you do it in linear time&nbsp;O(n)&nbsp;/possibly in a single pass?</li>
<li>Space complexity should be&nbsp;O(n).</li>
<li>Can you do it like a boss? Do it without using any builtin function like&nbsp;__builtin_popcount&nbsp;in c++ or in any other language.</li></ul>
<p>Hint:</p>
<ol><ol><li>You should make use of what you have produced already.</li>
<li>Divide the numbers in ranges like [2-3], [4-7], [8-15] and so on. And try to generate new range from previous.</li>
<li>Or does the odd/even status of the number help you in calculating the number of 1s?</li></ol></ol>
<p>解题思路：</p>
<p>0 &nbsp; &nbsp; 0000</p>
<p>1 &nbsp; &nbsp; 0001</p>
<p>2 &nbsp; &nbsp; 0010</p>
<p>3 &nbsp; &nbsp; 0011</p>
<p>4 &nbsp; &nbsp; 0100</p>
<p>5 &nbsp; &nbsp; 0101</p>
<p>6 &nbsp; &nbsp; 0110</p>
<p>7 &nbsp; &nbsp; 0111</p>
<p>8 &nbsp; &nbsp; 1000</p>
<p>9 &nbsp; &nbsp; 1001</p>
<p>10 &nbsp; 1010</p>
<p>11 &nbsp; 1011</p>
<p>12 &nbsp; 1100</p>
<p>13 &nbsp; 1101</p>
<p>14 &nbsp; 1110</p>
<p>15 &nbsp; 1111</p>
<p>........</p>
<p>观察上面的情况，我们发现0,1,2-3,4-7,8-15为一组，且每组开头的1的位数都是1。每组其余的数都可以用本组开头的数加上另一个差值。且这两个数都已经在前面算过了。</p>
<p>代码如下：</p>
<div>
<pre class="prettyprint linenums">public class Solution{<br />
	public int[] countBits(int num){<br />
		int[] res = new int[num + 1];<br />
		int pow = 1, k = 1;<br />
		res[0] = 0;<br />
		while(k &lt;= num){<br />
			if(k == pow){<br />
				pow *= 2;<br />
				res[k++] = 1;<br />
			} else {<br />
				res[k] = res[pow / 2 ] + res[k - pow / 2];<br />
				k++;<br />
			}<br />
		}<br />
		return res;<br />
	}<br />
}
</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdjmxqd.html">java设计模式之--单例模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96ojzj9.html">5&period;6 JS中基本包装类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql5pke8.html">关于easyui遇到的一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlk7x18.html">&lbrack;leetcode&rsqb; 根据String数组构造TreeNode，用于LeetCode树结构相关的测试用例</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rmy2m8.html">bootstrap fileinput-上传回调</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mvy4r8.html">客户端安全-csrf</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z7n6n9.html">ASP&period;NET下载远程图片保存到本地的方法、保存抓取远程图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z11wgx9.html">319&period; Bulb Switcher&mdash;&mdash;本质：迭代观察，然后找规律</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn47r2q.html">从ActionFilterAttribute向view传送数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjojoz9.html">Ruby自学笔记（三）&mdash; 方法Method</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdr1648.html">c&plus;&plus;学习&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp5z1jq.html">Git的Bug分支----临时保存现场git stash</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljogye9.html">页面加载完毕执行多个JS函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pkldj8.html">1&period;2 PCI总线的信号定义</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd42md9.html">SQL server脚本语句积累</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj4dwk9.html">Magento 2 自带模态的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojze5pq.html">python3 deque（双向队列）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlle436q.html">运行go服务器后台挂起&lpar;不看调试信息&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2z3wj9.html">npm scripts 脚本基础指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2kp319.html">18 os&sol;os&period;path模块中关于文件&sol;目录常用的函数使用方法 （转）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8z144pd9.html">js 判断是否为chrome浏览器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj335k9.html">Ubuntu的LTS版本</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnwkgrq.html">总结：Unity3D游戏上线后的流程回顾</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oyd649.html">SystemInfo&period;deviceUniqueIdentifier 返回机器码</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm5z349.html">hadoop浅尝  hadoop与hbase交互</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd160r8.html">oracle RAC－－归档日志的开启方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd167r8.html">Appboy 基于 MongoDB 的数据密集型实践</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oyz2j9.html">JavaScript 隐式转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj3vk49.html">hdu 4676 Sum Of Gcd</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xvkrr9.html">李洪强iOS开发之OC语言构造方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
